#include "jukebox.h"

extern char *getenv(const char *name);
extern char *inpstr();
extern mp3file *mp3w;
void askrplaylist();
void writeplaylist();
int readplaylist();

extern int w, warn, stslin, autohelp, lpos;
extern char versions[], status[], confdir[], warnstat[];

void askwplaylist(int end)
{
  int i, c;
  int list = FALSE;
  char string[MAXLEN];
  mp3file *mp3a;
  mp3a = mp3w;
  do
  {
    if (mp3a->pos > 0)
      list = TRUE;
    mp3a = mp3a->n;
  } while (mp3a != mp3w);
  if (list)
    do
    {
      warn = 0;
      move(stslin, 0);
      for (i=0; i<strlen(status); ++i)
        printw(" ");
      if (has_colors())
        attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
      else
        attrset(A_NORMAL);
      move(stslin, 0);
      c = 'y';
      if (end)
      {
        move(stslin, 0);
        printw(" Do you want to write the playlist? [N/y] ");
        nocbreak();
        cbreak();
        c = getch();
      }  
      if ((c == 'y') | (c == 'Y'))
      {
        if ((56+strlen(versions)) < w)
        {
          move(stslin, 0);
          printw(" Write playlist to [=list]:                             ");
          move(stslin, 28);
          leaveok(stdscr, FALSE);
          echo();
          getnstr(string, w-strlen(versions)-30);
          noecho();
          leaveok(stdscr, TRUE);
          writeplaylist(string);
        }
        else
        {
          move(stslin, 0);
          printw(" Write playlist to =list? [N/y] ");
          nocbreak();
          cbreak();
          c = getch();
          string[0] = 0;
          if ((c == 'y') | (c == 'Y'))
            writeplaylist(string);
          else
          {
            strcpy(status, " playlist not written");
            autohelp = 80;
          }
        }
      }
      if ((end) & (warn > 0))
      {
        move(stslin, 0);
        if (has_colors())
          attrset(COLOR_PAIR(C_WHITE1) | A_NORMAL);
        else
          attrset(A_STANDOUT);
        printw("%s", status);
        if (has_colors())
          attrset(COLOR_PAIR(C_BLUE2) | A_NORMAL);
        else
          attrset(A_STANDOUT);
        for (i=strlen(status); i<(w-strlen(versions)); ++i)
          printw(" ");
        getch();
      }
    } while (warn > 0);
}

void writeplaylist(char *listfile)
{
  int i, j;
  mp3file *mp3a, *mp3o;
  char outfile[MAXLEN];
  FILE *out;
  if (listfile[0] == 0)
    sprintf(outfile, "%s/list", confdir);
  else
    if ((listfile[0] == '=') | (listfile[0] == '~'))
    {
      if (listfile[0] == '=')
        sprintf(outfile, "%s", confdir);
      else
        if (getenv("HOME")) 
          sprintf(outfile, "%s", (char *) getenv("HOME"));
        else
          outfile[0] = 0;
      listfile[0] = '/';
      if (listfile[1] == '/')
      {
        i = 1;
        j = strlen(outfile);
        while((outfile[j++] = listfile[i++]) != 0);
      }
      else
        sprintf(outfile, "%s%s", outfile, listfile);
    }
    else
      strcpy(outfile, listfile);
  if ((out = fopen(outfile, "wt")) == NULL)
  {
    sprintf(warnstat, " can not open %s ", outfile);
    warn = 100;
  }
  else
  {
    fprintf(out, "# Playlist created by %s %s; %i entries\n", PTITLE, versions, lpos);
    i = 1;
    mp3a = mp3w;
    mp3o = mp3w;
    do
    {
      if (mp3a->pos == i)
      {
        fprintf(out, "%s\n", mp3a->fname);
        mp3o = mp3a;
        i = i+1;
      }
      mp3a = mp3a->n;
      /* fprintf(out, "%s %i\n", mp3a->fname, i); */
    } while ((mp3a != mp3o) & (lpos >= i));
    fclose(out);
    sprintf(status, " playlist saved as %s", outfile);
    autohelp = 80;
  }  
}

void askrplaylist(void)
{
  int i;
  char string[MAXLEN];
  warn = 0;
  move(stslin, 0);
  for (i=0; i<strlen(status); ++i)
    printw(" ");
  if (has_colors())
    attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
  else
    attrset(A_NORMAL);
  if ((56+strlen(versions)) < w)
  {
    move(stslin, 0);
    printw(" Read playlist from [=list]:                             ");
    move(stslin, 29);
    leaveok(stdscr, FALSE);
    echo();
    getnstr(string, w-strlen(versions)-30);
    noecho();
    leaveok(stdscr, TRUE);
  }
  else
    string[0] = 0;
  readplaylist(string);
}

int readplaylist(char *listfile)
{
  char infile[MAXLEN];
  char title[MAXLEN];
  mp3file *mp3a, *mp3o;
  FILE *in;
  if (listfile[0] == 0)
    sprintf(infile, "%s/list", confdir);
  else
    if (listfile[0] == '=')
    {
      listfile[0] = '/';
      sprintf(infile, "%s%s", confdir, listfile);
    }
    else
      strcpy(infile, listfile);
  if ((in = fopen(infile, "r")) != NULL)
  {
    mp3a = mp3w;
    mp3o = mp3w;
    do
    {
      do
      {
        inpstr(title, in);
      } while (title[0] == '#');
      if (title[0] == 0)
        break;
      do
      {
        if ((strcmp(mp3a->fname, title) == 0) & (mp3a->pos == 0))
        {
          lpos = lpos+1;
          mp3a->pos = lpos;
          mp3o = mp3a;
        }
        mp3a = mp3a->n;
      } while (mp3a != mp3w);
    } while (TRUE);
    fclose(in);
    sprintf(status, " playlist taken from %s ", infile);
    return TRUE;
  }
  else
    return FALSE;
}
