#include "jukebox.h"
#include <time.h>

extern unsigned long int strtoul(const char *nptr, char **endptr, int base);
extern pid_t childproc();
extern void count();
extern void askwplaylist();
extern void askrplaylist();
extern void writeplaylist();
extern int readplaylist();
extern void drawscreen();
extern void scinit();
extern void resize();
void finish();

int offset = 0;                     /* Anzahl der nicht angezeigten Titel (bzw. 1. angezeigter minus 1) */
int c, h, w;                        /* eingegebenes Zeichen, Anz. der darstellbaren Titel, Zeilenbreite */
int ready = 0;                      /* 1: ein Titel wurde gerade beendet */
int hup = 0;                        /* 1: startendes/r Terminal oder Prozess ist weg */
int cpause = 0;                     /* 1: Widergabe wurde angehalten */
int load = 0;                       /* 1: Titel wird gerade ins Tempfile bertragen */
extern int cpymp3, mpwait, active;
extern int debug;
int help;
int scrnew = 0;                     /* Beim Screen-Resize wird der Wert auf 2 gesetzt und der Bildsch. 2x aufgebaut */
int warn = 0;                       /* >0: in der statuszeile wird eine Warn-/Fehlermeldung gezeigt */
int info = FALSE;                   /* TRUE: Infozeilen zum MP3 File werden angezeigt */
int stslin;
extern int fcnt;
int fpnt = 1;
int lpos = 0;
int screensize = 0;
int autohelp = 80;
extern int skeybar;                 /* TRUE: in der untersten Zeile wird die Funktionstastenbelegung angezeigt */
extern int showtime;                /* 0: keine Zeitanzeige, 1: Restzeit, 2: Spielzeit */
extern int vtime;                   /* 0: Zeitangabe ungltig, 1: gltig */
int seqn;
extern time_t timel, times;         /* Lnge des Titels in Sekunden, Startzeit */
pid_t cpid;                         /* Process-ID der Startroutine fr den Player; -cpid = Group-ID der Unterprozesse */
mp3file *mp3w, *mp3a, *mp3o, *mp3p; /* Zeiger auf Anfang, aktuelles-, voriges-Element, Cursor-Position */
extern char status[], tmpdir[];     /* Status in der untersten Bilschirmzeile (Titel) */
char warnstat[160];                 /* Warnung in der untersten Bilschirmzeile */
char versions[MAXLEN];              /* Versionsnummer */
char findbufa[256];
char findbuft[256];
char *findcnt;
int seq[16];

void interactive(void)              /* wertet die Tastatureingaben aus und startet die Ausgabe */
{
  int i;
  short r, g, b;
  int c = 0;
  int c2, c3;
  int fpos = 1;
  int first = 0;
  int second = 0;
  int findd = 1;
  time_t timeo = 0;
  char newpos[4];
  /* char title[MAXLEN]; */
  char finds[MAXLEN];
  char string[MAXLEN];
  FILE *in;

  finds[0] = 0;
  help = 1;
  
  (void) signal(SIGINT, finish);    /* arrange interrupts to terminate */
  (void) signal(SIGTERM, finish);   /* arrange interrupts to terminate */
  (void) signal(SIGQUIT, finish);   /* arrange interrupts to terminate */
  (void) signal(SIGSTOP, SIG_IGN);  /* dont be paralysed while killall5 */

  (void) initscr();                 /* initialize the curses library */
/*  (void) start_color();              initialize color changing */

  (void) signal(SIGWINCH, resize);  /* arrage interrupt to resize the screen */
  (void) signal(SIGCHLD, count);    /* arrange interrupt for stopped or terminated child, i don't like zombies */
  
  keypad(stdscr, TRUE);             /* enable keyboard mapping */
  (void) nonl();                    /* tell curses not to do NL->CR/NL on output */
  (void) halfdelay(1);              /* take input chars one at a time, no wait for \n */
  (void) noecho();                  /* don't echo input */
  (void) leaveok(stdscr, TRUE);     /* hide cursor */

  if (has_colors())
  {
    start_color();
    /*
     * Simple color assignment, often all we need.
    */
    init_pair(C_BLACK, COLOR_BLACK, COLOR_WHITE);
    init_pair(C_WHITE1, COLOR_WHITE, COLOR_RED);
    init_pair(C_WHITE2, COLOR_WHITE, COLOR_BLUE);
    init_pair(C_WHITE3, COLOR_WHITE, COLOR_GREEN);
    init_pair(C_RED, COLOR_RED, COLOR_BLACK);
    init_pair(C_RED2, COLOR_RED, COLOR_WHITE);
    init_pair(C_GREEN, COLOR_GREEN, COLOR_BLACK);
    /* init_pair(C_GREEN2, COLOR_GREEN, COLOR_BLUE); */
    init_pair(C_BLUE, COLOR_BLUE, COLOR_BLACK);
    init_pair(C_BLUE2, COLOR_BLUE, COLOR_WHITE);
    init_pair(C_BLUE3, COLOR_BLACK, COLOR_BLUE);
    init_pair(C_BLUE4, COLOR_WHITE, COLOR_BLUE);
    init_pair(C_MAGENTA, COLOR_MAGENTA, COLOR_WHITE);
    init_pair(C_CYAN, COLOR_BLACK, COLOR_CYAN);
    init_pair(C_YELL, COLOR_YELLOW, COLOR_BLACK);
    init_pair(C_YELL2, COLOR_BLACK, COLOR_YELLOW);   
    /* if (can_change_color())
    { */
      /* COLORS = 11;
      color_content(COLOR_GREEN, r, g, b); */
      r = 0;
      g = 200;
      b = 0;
      init_color(COLOR_BLUE, r, g, b);
    /*  do
      {
      }
      while (1);
     } */
  }

  mp3p = mp3w;
  do
  {
    do
    {
      scinit();
      switch (c)
      {
        case 'k':                     /* Coursor nach oben bewegen */
        case 'K':
      case '8':
      case KEY_UP:
        if (mp3p != mp3w)
        {
          info = FALSE;
          mp3p = mp3p->p;
          fpnt = fpnt-1;
        }
        break;
      case 'j':                     /* Coursor nach unten bewgen */
      case 'J':
      case '2':
      case KEY_DOWN:
        if (mp3p->n != mp3w)
        {
          info = FALSE;
          mp3p = mp3p->n;
          fpnt = fpnt+1;
          /* if (fpnt > (offset+h))
            offset = offset+1; */
        }
        break;
      case '7':                     /* Coursor auf erste Position */
      case KEY_HOME:
        if (mp3p != mp3w)
          info = FALSE;
        offset = 0;
        fpnt = 1;
        mp3p = mp3w;
        break;
      case 'G':                     /* Coursor auf letzte Position */
      case '1':
      case KEY_END:
        if (mp3p != mp3w->p)
          info = FALSE;
        offset = fcnt-h;
        fpnt = fcnt;
        mp3p = mp3w->p;
        break;
      case '9':                     /* Coursor eine Seite zurck */
      case KEY_PPAGE:
        if (mp3p != mp3w)
          info = FALSE;
        for (i=0; i<h; ++i)
        {
          if (mp3p->p != mp3w->p)
          {
            mp3p = mp3p->p;
            fpnt = fpnt-1;
            if (offset > 0)
              offset = offset-1;
          }
        }
        break;
      case '3':                     /* Coursor eine Seite vor */
      case KEY_NPAGE:
        if (mp3p != mp3w->p)
          info = FALSE;
        for (i=0; i<h; ++i)
        {
          if (mp3p->n != mp3w)
          {
            mp3p = mp3p->n;
            fpnt = fpnt+1;
            if (offset < (fcnt-h))
              offset = offset+1;
          }
        }
        break;
      case '/':
        findd = 1;
      case '?':
        if ( c == '?')
          findd = 0;
        move(stslin, 0);
        for (i=0; i<strlen(status); ++i)
          printw(" ");
        if (has_colors())
          attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
        else
          attrset(A_NORMAL);
        move(stslin, 0);
        printw(" Find: ");
        move(stslin, 7);
        leaveok(stdscr, FALSE);
        echo();
        getnstr(finds, w-strlen(versions)-8);
        noecho();
        leaveok(stdscr, TRUE);
        findcnt = &finds;
        do
        {
          *findcnt++ = tolower(*findcnt);
        } while(*findcnt != 0);
      case 'n':  
      case 'N':
        mp3o = mp3p;
        if (findd == 1)
        {
          do
          {
            mp3p = mp3p->n;
            fpnt = fpnt+1;
            if (mp3p == mp3w)
              fpnt = 1;
            strcpy(findbufa, mp3p->artist);
            findcnt = &findbufa;
            do
            {
              *findcnt++ = tolower(*findcnt);
            } while(*findcnt != 0);
            strcpy(findbuft, mp3p->title);
            findcnt = &findbuft;
            do
            {
              *findcnt++ = tolower(*findcnt);
            } while(*findcnt != 0);
          } while ((mp3o != mp3p) & (strstr(findbufa, finds) == 0) & (strstr(findbuft, finds) == 0));
        }
        else
        {
          do
          {
            mp3p = mp3p->p;
            fpnt = fpnt-1;
            if (mp3p == mp3w->p)
              fpnt = fcnt;
          } while ((mp3o != mp3p) & (strstr(mp3p->artist, finds) == 0) & (strstr(mp3p->title, finds) == 0));
        }
        break;
      case 'z':                     /* alles deselektieren */
      case 'Z':
      case KEY_F(4):
      case KEY_CLEAR:
      case KEY_UNDO:
        if (lpos == 0)
          break;
        move(stslin, 0);
        for (i=0; i<strlen(status); ++i)
          printw(" ");
        if (has_colors())
          attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
        else
          attrset(A_NORMAL);
        move(stslin, 0);
        printw(" Do you want to deselect all? [N/y] ");
        do c2 = getch();
        while (c2 == -1);
        if ((c2 != 'y') & (c2 != 'Y'))
          break;
        mp3a = mp3w;
        do
        {
          if ((mp3a->pos != 1) | (active == 0))
            mp3a->pos = 0;
          mp3a = mp3a->n;
        } while (mp3a != mp3w);
        if (active == 0)
        {
          fpos = 1;
          lpos = 0;
          first = 0;
        }
        else 
        {
          fpos = 2;
          lpos = 1;
        }
        second = 0;
        break;
      case 'a':                     /* alles selektieren */
      case 'A':
      case KEY_F(3):
        if (lpos == fcnt)
          break;
        move(stslin, 0);
        for (i=0; i<strlen(status); ++i)
          printw(" ");
        if (has_colors())
          attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
        else
          attrset(A_NORMAL);
        move(stslin, 0);
        printw(" Do you want to select all? [N/y] ");
        do c2 = getch();
        while (c2 == -1);
        if ((c2 != 'y') & (c2 != 'Y'))
          break;
        second = 0;
        mp3a = mp3w;
        do
        {
          if (mp3a->pos == 0)
          {
            lpos = lpos+1;
            fpos = lpos;
            mp3a->pos = fpos;
          }  
          mp3a = mp3a->n;
        } while (mp3a != mp3w);
        break;
      case 'i':                     /* Titel in Playlist einfgen */
      case 'I':
      case '0':
      case KEY_IC:
      case KEY_IL:
      case KEY_SELECT:
        if (mp3p->pos == 0)
        {
          if (fpos > lpos)
            fpos = lpos;
          if (fpos <= 0)
            fpos = 1;
          if ((fpos == 1) & (active != 0))
            fpos = 2;
          mp3a = mp3w;
          do
          {
            if (mp3a->pos >= fpos)
              mp3a->pos = mp3a->pos+1;
            mp3a = mp3a->n;
          } while (mp3a != mp3w);
          mp3p->pos = fpos;
          lpos = lpos+1;
          if (fpos == 1)
            first = 0;
          if (fpos == 2)
            second = 0;
        }
        break;
      case ' ':                     /* Titel an Playlist anfgen */
        if (mp3p->pos == 0)
        {
          lpos = lpos+1;
          fpos = lpos;
          mp3p->pos = fpos;
          if (fpos == 2)
            second = 0;
        }
        break;
      case 13:                     /* Titel an Playlist anfgen */
        if (mp3p->pos == 0)
        {
          lpos = lpos+1;
          fpos = lpos;
          mp3p->pos = fpos;
          if (fpos == 2)
            second = 0;
          if (mp3p->n != mp3w)
          {
            info = FALSE;
            mp3p = mp3p->n;
            fpnt = fpnt+1;
          }
        }
        break;
      case 'd':                     /* Titel deselektieren */
      case 'D':
      case ',':
      case KEY_DC:
      case KEY_DL:
      case KEY_SUSPEND:
      case 127:
        if ((mp3p->pos != 0) & ((mp3p->pos != 1) | (active == 0)))
        {
          mp3a = mp3w;
          do
          {
            if (mp3a->pos > mp3p->pos)
              mp3a->pos = mp3a->pos-1;
            mp3a = mp3a->n;
          } while (mp3a != mp3w);
          lpos = lpos-1;
          fpos = mp3p->pos;
          mp3p->pos = 0;
          if ((fpos == 1) & (cpymp3 == 1) & (active == 0))
            first = 0;
          if ((fpos == 2) & (cpymp3 == 1))
            second = 0;
        }
        break;
      case '#':                     /* Titel an bestimmte Position in Playlist setzen */
      case KEY_F(5):
        if (mp3p->pos == 0)
        {
          move(stslin, 0);
          for (i=0; i<strlen(status); ++i)
            printw(" ");
          if (has_colors())
            attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
          else
            attrset(A_NORMAL);
          move(stslin, 0);
          printw(" Enter Position:     ");
          move(stslin, 17);
          leaveok(stdscr, FALSE);
          echo();
          getnstr(newpos, 3);
          noecho();
          leaveok(stdscr, TRUE);
          if (newpos[0] != 0)
          {
            fpos = strtoul(newpos, NULL, 10);
            if (fpos < 3)
              second = 0;
            if (fpos > lpos)
            {
              lpos = lpos+1;
              mp3p->pos = lpos;
              fpos = lpos;
            }
            else
            {
              if (fpos < 1)
                fpos = 1;
              if ((fpos == 1) & (active > 0))
                fpos = 2;
              mp3a = mp3w;
              do
              {
                if (mp3a->pos >= fpos)
                  mp3a->pos = mp3a->pos+1;
                mp3a = mp3a->n;
              } while (mp3a != mp3w);
              mp3p->pos = fpos;
              lpos = lpos+1;
            }
            if ((fpos == 1) & (active == 0))
              first = 0;
            if (fpos == 2)
              second = 0;
          }
        }
        break;
      case 'p':                     /* Play / Pause */
      case 'P':
      case KEY_F(9):
        if (active == 0)
          active = 2;
        else
        {
          if (cpause == 0)
          {
            kill(-cpid, SIGTSTP);
            cpause = 1;
            vtime = 0;
          }
          else
          {
            kill(-cpid, SIGCONT);
            cpause = 0;
          }
        }
        break;
      case 's':                     /* Start / Stop */
      case 'S':
      case KEY_F(8):
        if (active == 0)
          active = 2;
        else
        {
          kill(-cpid, SIGTERM);
          if (cpause == 1)
            kill(-cpid, SIGCONT);
          active = 0;
          status[0] = 0;
          cpause = 0;
        }
        break;
      case 'r':                     /* Titel neu starten */
      case 'R':
      case KEY_LEFT:
      case KEY_PREVIOUS:
      case KEY_RESTART:
        if ((active == 1) & (ready == 0))
        {
          kill(-cpid, SIGTERM);
          if (cpause == 1)
            kill(-cpid, SIGCONT);
          active = 2;
          cpause = 0;
        }
        break;
      case 'f':                     /* nchsten Titel starten */
      case 'F':
      case KEY_RIGHT:
      case KEY_NEXT:
        if ((active == 1) & (ready == 0))
        {          
          kill(-cpid, SIGTERM);
          if (cpause == 1)
            kill(-cpid, SIGCONT);
          cpause = 0;
        }
        break;
      case 't':
      case 'T':
        showtime = showtime + 1;
        if (showtime == 3)
          showtime = 0;
        if (active == 0)
        {
          help = 1;
          autohelp = 80;
          if (showtime == 0)
            strcpy(status, "Time Information Off");
          else if (showtime == 1)
            strcpy(status, "Display Remaining Time");
          else if (showtime == 2)
            strcpy(status, "Dispaly Elapsed Time");
        }
        break;
      case 9:                       /* zeigt Informationen ber Titel unter Cursor an */
      case KEY_F(11):
        if (info == FALSE)
          info = TRUE;
        else
          info = FALSE;
        break;
      case 'w':
      case 'W':
      case KEY_F(6):
        askwplaylist(FALSE);
        break;
      case 'e':
      case 'E':
      case KEY_F(7):
        askrplaylist();
        break;
      case 'b':
      case 'B':
      case KEY_F(2):
        if (skeybar)
          skeybar = FALSE;
        else
          skeybar = TRUE;
        break;
      case 'h':                     /* Hilfe */
      case 'H':
      case KEY_F(1):
      case KEY_HELP:
        autohelp = 1800;
      case 254:
        help = help+1;
        if (help == 17)
        {
          if (active > 0)
          {
            help = 0;
            mp3a = mp3w;
            do
            {
              if (mp3a->pos == 1)
                sprintf(status, " %s  %s", mp3a->artist, mp3a->title);
              mp3a = mp3a->n;
            } while (mp3a != mp3w);
          }
          else 
            help = 1;
        }
        switch (help)
        {
          case 1:
            strcpy(status, " Press 'H' or <F1> for help");
            break;
          case 2:
            strcpy(status, " <F2> show/hide keybar ( >= 67 columns required)");
            break;
          case 3:
            strcpy(status, " 'J', <UP> and 'K', <DOWN> move cursor");
            break;
          case 4:
            strcpy(status, " <SPACE> add title to the end of the playlist");
            break;
          case 5:
            strcpy(status, " 'I', <INS> insert title in playlist");
            break;
          case 6:
            strcpy(status, " 'D', <DEL> delete title from playlist");
            break;
          case 7:
            strcpy(status, " 'A', <F3> select all - 'Z', <F4> deselect all");
            break;
          case 8:
            strcpy(status, " '#', <F5> enter position for the title");
            break;
          case 9:
            strcpy(status, " 'W', <F6> write playlist to file");
            break;
          case 10:
            strcpy(status, " 'E', <F7> read playlist from file");
            break;
          case 11:
            strcpy(status, " 'S', <F8> start/stop - 'P', <F9> play/pause");
            break;
          case 12:
            strcpy(status, " 'R', <LEFT> rewind - 'F', <RIGHT> forewind");
            break;
          case 13:
            strcpy(status, " <TAB>, <F11> show info for mp3-file under the cursor");
            break;
          case 14:
            strcpy(status, " 'T' toggels display of remaining, elapsed, no time");
            break;
          case 15:
            strcpy(status, " '/', '?', 'N' search forwards, backwards, next");
            break;
          case 16:
            strcpy(status, " 'Q', 'X', <F10> Quit");
            break;
        }
    }
    drawscreen();
    do
    {
      /* ungetch('~');
      ungetch('1');
      ungetch('1');
      ungetch('['); */
      seqn = 0;
      seq[0] = 0;
      do
      {
        while(((seq[seqn] = getch()) != -1) & (seqn < 15) & (seq[0] == 27))
        {
          if(seqn > 0)
          {
            if((seq[seqn] != 27) & (seq[seqn] != 24) & (seq[seqn] != 26))
            {
              if((seq[1] == '[') & (seq[seqn] == '~'))
                break;
            }
            else
            {
              ungetch(seq[seqn]);
              break;
            }
          }
          seq[++seqn] = 0;
        }
      } while((seq[0] == -1) & (active == 0));
      c = seq[0];
      if (debug)
      {
        fprintf(stderr, "got starting char %i", c);
        seqn = 0;
        while (seq[seqn] != 0)
          fprintf(stderr, ", %i", seq[seqn++]);
        fprintf(stderr, "\n");
      }
      if ((active == 0) & (warn < 1))
        if ((autohelp-- < 1) & (c == -1))
        {
          c = 254;
          autohelp = 80;
        }
      if (timeo < time(NULL))
      {
        timeo = time(NULL);
        if (c == -1)
          c = 0;
      }
      if (warn > 0)
        warn = warn-1;
      if ((active == 1) & (ready == 1))
      {
        mp3a = mp3w;
        do
        {
          if (mp3a->pos > 0)
            mp3a->pos = mp3a->pos-1;
          mp3a = mp3a->n;
        } while (mp3a != mp3w);
        lpos = lpos-1;
        fpos = fpos-1;
        c = 0;
        active = 2;
        ready = 0;
        first = 0;
      }
      if (cpymp3 == 1)
      {
        if (first == 0)
        {
          if (second == 1)
          {
            load = 1;
            second = 0;
            strcpy(warnstat, " loading, please wait! ");
            drawscreen();
            sprintf(string, "mv -f %s/jukebox.second.mp3 %s/jukebox.first.mp3 2> /dev/null", tmpdir, tmpdir);
            in = popen(string, "r");
            pclose(in);
            if (mpwait == 1)
              sync();
            first = 1;
            load = 0;
          }
          else
          {
            mp3a = mp3w;
            do
            {
              if (mp3a->pos == 1)
              {
                load = 1;
                first = 1;
                strcpy(warnstat, " loading, please wait! ");
                mp3o = mp3a;
              }
              mp3a = mp3a->n;
            } while (mp3a != mp3w);
            if (first == 1)
            {
              drawscreen();
              sprintf(string, "cp -f %s %s/jukebox.first.mp3 2> /dev/null\n", mp3o->fname, tmpdir);
              in = popen(string, "r");
              pclose(in);
              if (mpwait == 1)
                sync();
              load = 0;
              if (active == 0)
                status[0] = 0;
              else
              {
                mp3a = mp3w;
                do
                {
                  if (mp3a->pos == 1)
                  {
                    sprintf(status, " %s  %s", mp3a->artist, mp3a->title);
                    help = 0;
                  }
                  mp3a = mp3a->n;
                } while (mp3a != mp3w);
              }
              drawscreen();
            }
          } 
        }
      }
      if ((active == 2) & (cpause == 0))
      {
        autohelp = 300;
        c = 0;
        active = 0;
        ready = 0;
        status[0] = 0;
        mp3a = mp3w;
        do
        {
          if (mp3a->pos == 1)
          {
            help = 0;
            sprintf(status, " %s  %s", mp3a->artist, mp3a->title);
            if (cpymp3 == 1)
            {
              /* if ((mpwait == 1) & (second < 2))
              { */
                while (load == 1);
                sprintf(string,"%s/jukebox.first.mp3", tmpdir);
                active = 1;
                cpid = childproc(string);
              /* } */
            }
            else
            {
              active = 1;
              cpid = childproc(mp3a->fname);
            }
            timel = mp3a->min * 60 + mp3a->sec;
            times = time(NULL);
            vtime = 1;
          }
          mp3a = mp3a->n;
        } while (mp3a != mp3w);
        if ((active == 0) & (hup == 1))
          finish();
      }  
      if (cpymp3 == 1)
      {
        if ((second != 1) & (mpwait == 0))
        {
          second = 0;
          mp3a = mp3w;
          do
          {
            if (mp3a->pos == 2)
            {
              load = 1;
              second = 1;
              help = 1;
              strcpy(status, " loading, please wait! ");
              mp3o = mp3a;
            }
            mp3a = mp3a->n;
          } while (mp3a != mp3w);
          if (second == 1)
          { 
            drawscreen();
            sprintf(string, "cp -f %s %s/jukebox.second.mp3 2> /dev/null\n", mp3o->fname, tmpdir);
            in = popen(string, "r");
            pclose(in);
            load = 0;
            if (active == 0)
              status[0] = 0;
            else
            {
              mp3a = mp3w;
              do
              {
                if (mp3a->pos == 1)
                {
                  help = 0;
                  sprintf(status, " %s  %s", mp3a->artist, mp3a->title);
                }
                mp3a = mp3a->n;
              } while (mp3a != mp3w);
            }
            drawscreen();
          }
        }
      }
    } while ((c == -1) & (scrnew == 0));
    if (scrnew > 0)
      scrnew = scrnew-1;
    /* if (c == 27)
    {
      c = getch();
      if (debug)
        fprintf(stderr, "got char %i\n", c);
    } */
    if ((seq[0] == 27) & (seq[1] == 91))
    {
      switch (seq[2])
      {
      case 72: c = '7';
                break;
      case 70: c = '1';
                break;
      case 49: if (seq[4] == '~')
                switch (seq[3])
                {
                  case 49: c = 'h';
                            break;
                  case 50: c = 'b';
                            break;
                  case 51: c = 'a';
                            break;
                  case 52: c = 'z';
                            break;
                }
                break;
      }
    }
  } while ((c != 'q') & (c != 'Q') & (c != 'x') & (c != 'X') & (c != KEY_F(10)) & (c != KEY_EXIT));
  move(stslin, 0);
  for (i=0; i<strlen(status); ++i)
    printw(" ");
  if (has_colors())
    attrset(COLOR_PAIR(C_WHITE2) | A_NORMAL);
  else
    attrset(A_NORMAL);
  move(stslin, 0);
  printw(" Do you want to quit? [Y/n] ");
  do c2 = getch();
  while (c2 == -1);
  /* do 
  {
    c2 = getch();
    printw(" %i ", c2);
  }
  while (c2 != 'q'); */
  } while ((c2 != 'y') & (c2 != 'Y') & (c2 != 13));
  askwplaylist(TRUE);
  finish(0);
}

static void lost(int sig)
{
  hup = 1;
}

void finish(int sig)         /* Bildschirm in definierten Zustand bringen und Unterprozesse abschieen */
{
  char string[MAXLEN];
  FILE *in;

  endwin();
  sprintf(string, "rm -f %s/jukebox.first.mp3 %s/jukebox.second.mp3 %s/jukebox.index > /dev/null 2> /dev/null", tmpdir, tmpdir, tmpdir);
  in = popen(string, "r");
  pclose(in);
  if (active != 0)
  {
    kill(-cpid, SIGTERM);
    if (sig != 0)
    {
      fprintf(stderr, "AAAAAAAAAAAARRRRRRRRRRRRGGGGGGGGGGGGHHHHHHHHHHHH !    trying to save playlist \n");
      strcpy(string, "=.auto");
      writeplaylist(string);
      fprintf(stderr, "%s\n", status);
    }
  }
  if (screensize != 2)
    fprintf(stderr, "screensize error   \n");
  fprintf(stderr, "terminated [0K\n");
  exit(0);
}
